; Source created with Parsic Version 3.x

; at              : 16/08/02 18.07.05


; Project File    : c:\PROGRA~1\PARSIC\MOTORI\MOCSTART.PIC

; Project Version : 1.0.96

; Created         : 24/01/02 10.03.00

; Last change     : 16/08/02 18.06.57

	PROCESSOR 16C716

	INCLUDE P16C716.INC

	RADIX DEC


	__IDLOCS H'0100'

	__CONFIG _CP_ALL & _PWRTE_ON & _WDT_ON & _BODEN_ON & _XT_OSC

; Diverses

ZERO	EQU Z	; ZERO-Flag
CARRY	 EQU C	; CARRY-Flag


; Variable

SYS_WSAV	= 32	; located in Bank 0
SYS_SSAV	= 33	; located in Bank 0
SYS_TMP1	= 34	; located in Bank 0
MF1	= 43	; located in Bank 0
MF1_HI	= 44	; located in Bank 0
S0	= 45	; located in Bank 0
ZR1	= 46	; located in Bank 0
ZR1_FD	= 47	; located in Bank 0
ZR2	= 48	; located in Bank 0
ZR2_FD	= 49	; located in Bank 0
TR1	= 50	; located in Bank 0
TR1_HI	= 51	; located in Bank 0
OS1_FD	= 52	; located in Bank 0
MF2	= 53	; located in Bank 0
MF2_HI	= 54	; located in Bank 0
MF2_FD	= 55	; located in Bank 0
S1	= 56	; located in Bank 0
TR2	= 57	; located in Bank 0
TR2_HI	= 58	; located in Bank 0
TR3	= 59	; located in Bank 0
TR3_HI	= 60	; located in Bank 0
TR4	= 61	; located in Bank 0
TR4_HI	= 62	; located in Bank 0
ZR3	= 63	; located in Bank 0
ZR3_FD	= 64	; located in Bank 0
ZR4	= 65	; located in Bank 0
ZR4_FD	= 66	; located in Bank 0
S2	= 67	; located in Bank 0
TR5	= 68	; located in Bank 0
TR5_HI	= 69	; located in Bank 0
MF3	= 70	; located in Bank 0
MF3_HI	= 71	; located in Bank 0
MF3_FD	= 72	; located in Bank 0
S3	= 73	; located in Bank 0
OS2_FD	= 74	; located in Bank 0
OS3_FD	= 75	; located in Bank 0
ZR5	= 76	; located in Bank 0
ZR5_FD	= 77	; located in Bank 0
TR6	= 78	; located in Bank 0
TR6_HI	= 79	; located in Bank 0
S4	= 80	; located in Bank 0
OS4_FD	= 81	; located in Bank 0
RAM	= 82	; located in Bank 0
SYS_WSAV2	= 160	; located in Bank 1

	ERRORLEVEL -302	; disable warning (Bankswitching)
	ERRORLEVEL -306	; disable warning (Pageswitching)

;****************************************
;Programmanfang
;****************************************

	ORG 0

	CLRF STATUS	; switch to RAM-Bank 0
	GOTO SYS_INIT
	NOP
	NOP

;****************************************
;Interrupt-Adress
;****************************************

	MOVWF SYS_WSAV	; save register
	SWAPF STATUS,W
	CLRF STATUS	; bank 0
	MOVWF SYS_SSAV

	BCF INTCON,T0IF	; Interrupt quitieren

	BCF STATUS,RP0	; Bank 0
	INCFSZ MF1,F
	GOTO SYS_INT_LABEL_0
	INCF MF1_HI,F

SYS_INT_LABEL_0
	INCFSZ TR1,F
	GOTO SYS_INT_LABEL_1
	INCF TR1_HI,F

SYS_INT_LABEL_1
	INCFSZ MF2,F
	GOTO SYS_INT_LABEL_2
	INCF MF2_HI,F

SYS_INT_LABEL_2
	INCFSZ TR2,F
	GOTO SYS_INT_LABEL_3
	INCF TR2_HI,F

SYS_INT_LABEL_3
	INCFSZ TR3,F
	GOTO SYS_INT_LABEL_4
	INCF TR3_HI,F

SYS_INT_LABEL_4
	INCFSZ TR4,F
	GOTO SYS_INT_LABEL_5
	INCF TR4_HI,F

SYS_INT_LABEL_5
	INCFSZ TR5,F
	GOTO SYS_INT_LABEL_6
	INCF TR5_HI,F

SYS_INT_LABEL_6
	INCFSZ MF3,F
	GOTO SYS_INT_LABEL_7
	INCF MF3_HI,F

SYS_INT_LABEL_7
	INCFSZ TR6,F
	GOTO SYS_INT_LABEL_8
	INCF TR6_HI,F

SYS_INT_LABEL_8

EXITINT

	SWAPF SYS_SSAV,W	; Register zurck
	MOVWF STATUS
	SWAPF SYS_WSAV,F
	SWAPF SYS_WSAV,W

	RETFIE	; RETurn From Interrupt and Enable GIE


;****************************************
; Subroutines
;****************************************


;****************************************
;Initialisierung
;****************************************


SYS_INIT

	MOVLW B'00100000'
	MOVWF INTCON

; Ausgangs-Pegel setzen, bevor die Richtung gesetzt wird

	BCF STATUS,RP0	; Bank 0
	MOVLW B'00000000'
	MOVWF PORTA

	MOVLW B'11000011'
	MOVWF PORTB

	MOVLW 143
	BSF STATUS,RP0	; Bank 1
	MOVWF OPTION_REG

	MOVLW 7	; all digital
	MOVWF ADCON1

; Richtung setzen

	MOVLW B'11111111'
	MOVWF TRISA

	MOVLW B'00111100'
	MOVWF TRISB

; init vars


; Clear RAM

	MOVLW 32
	MOVWF FSR
CR1
	CLRF INDF
	INCF FSR,F
	BTFSS FSR,7
	GOTO CR1
	BSF FSR,5
CR2
	CLRF INDF
	INCF FSR,F
	BTFSS FSR,6
	GOTO CR2

	MOVLW B'10000000'
	BCF STATUS,RP0	; Bank 0
	MOVWF S1

	CLRF TMR0
	BCF INTCON,T0IF
	BSF INTCON,GIE	; Interrupt freigeben

;**********************************
;******* Haupt-Programm ***********
;**********************************

MAIN

	CLRWDT

;***************************************************
; Anzug-Verzgerung -> MF1
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BTFSC PORTA,0	; Eingang auf High ?
	GOTO LABEL_MF1_CHKTIME	; Ja

; RESET

	CLRF MF1
	CLRF MF1_HI
	BCF S0,0
	GOTO LABEL_MF1_EXIT	; raus

LABEL_MF1_CHKTIME

	BCF STATUS,RP0	; Bank 0
	BTFSC S0,0	; Ausgang schon auf High ?
	GOTO LABEL_MF1_EXIT	; Ja

	MOVLW 3
	SUBWF MF1_HI,W
	BTFSS STATUS,CARRY
	GOTO LABEL_MF1_EXIT

	MOVLW 209
	SUBWF MF1,W
	BTFSS STATUS,CARRY
	GOTO LABEL_MF1_EXIT

	BSF S0,0
LABEL_MF1_EXIT

;***************************************************
; Zhler -> ZR1
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BTFSS S0,2	; Reset ?
	GOTO LABEL_ZR1_COUNT
	CLRF ZR1
	GOTO LABEL_ZR1_SETOUT

LABEL_ZR1_COUNT

; Test auf positive Flanke

	BCF STATUS,RP0	; Bank 0
	BTFSC ZR1_FD,0
	GOTO LABEL_ZR1_SETFD
	BTFSS S0,0
	GOTO LABEL_ZR1_SETFD

	INCF ZR1,F

LABEL_ZR1_SETOUT

; Output Q0

	BTFSS ZR1,0
	GOTO LABEL_ZR1_SETOUT0
	BSF S0,3
	GOTO LABEL_ZR1_SETOUT0_END
LABEL_ZR1_SETOUT0
	BCF S0,3
LABEL_ZR1_SETOUT0_END

LABEL_ZR1_SETFD

	BCF STATUS,RP0	; Bank 0
	BTFSS S0,0
	GOTO LABEL_ZR1_SETFD2
	BSF ZR1_FD,0
	GOTO LABEL_ZR1_END
LABEL_ZR1_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF ZR1_FD,0
LABEL_ZR1_END

;***************************************************
; UND - Gatter -> LG1
;***************************************************

LABEL_LG1_1
	BTFSC PORTA,1
	GOTO LABEL_LG1_FALSE
LABEL_LG1_2
	BTFSS S0,3
	GOTO LABEL_LG1_FALSE

LABEL_LG1_TRUE
	BCF PORTB,6
	GOTO LABEL_LG1_ENDE
LABEL_LG1_FALSE
	BCF STATUS,RP0	; Bank 0
	BSF PORTB,6
LABEL_LG1_ENDE
;***************************************************
; Vergleich -> IF1
;***************************************************

	MOVLW 2
	SUBWF ZR1,W	; F - W -> W

LABEL_IF1_CHECK
	BCF STATUS,RP0	; Bank 0
	BTFSS STATUS,ZERO	; Test auf -> =
	GOTO LABEL_IF1_FALSE

LABEL_IF1_TRUE
	BSF S0,1
	GOTO LABEL_IF1_EXIT

LABEL_IF1_FALSE
	BCF S0,1

LABEL_IF1_EXIT
;***************************************************
; ODER - Gatter -> LG2
;***************************************************

LABEL_LG2_1
	BTFSC PORTA,1
	GOTO LABEL_LG2_TRUE
LABEL_LG2_2
	BTFSC S0,1
	GOTO LABEL_LG2_TRUE

LABEL_LG2_FALSE
	BCF S0,2
	GOTO LABEL_LG2_ENDE
LABEL_LG2_TRUE
	BCF STATUS,RP0	; Bank 0
	BSF S0,2
LABEL_LG2_ENDE
;***************************************************
; Zhler -> ZR2
;***************************************************

	BTFSS S0,7	; Reset ?
	GOTO LABEL_ZR2_COUNT
	CLRF ZR2
	GOTO LABEL_ZR2_SETOUT

LABEL_ZR2_COUNT

; Test auf positive Flanke

	BCF STATUS,RP0	; Bank 0
	BTFSC ZR2_FD,0
	GOTO LABEL_ZR2_SETFD
	BTFSS S0,5
	GOTO LABEL_ZR2_SETFD

	INCF ZR2,F

LABEL_ZR2_SETOUT

LABEL_ZR2_SETFD

	BCF STATUS,RP0	; Bank 0
	BTFSS S0,5
	GOTO LABEL_ZR2_SETFD2
	BSF ZR2_FD,0
	GOTO LABEL_ZR2_END
LABEL_ZR2_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF ZR2_FD,0
LABEL_ZR2_END

;***************************************************
; UND - Gatter -> LG3
;***************************************************

LABEL_LG3_1
	BTFSS S0,3
	GOTO LABEL_LG3_FALSE
LABEL_LG3_2
	BTFSS S0,6
	GOTO LABEL_LG3_FALSE
LABEL_LG3_3
	BTFSC S0,4
	GOTO LABEL_LG3_FALSE

LABEL_LG3_TRUE
	BSF S0,5
	GOTO LABEL_LG3_ENDE
LABEL_LG3_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF S0,5
LABEL_LG3_ENDE
;***************************************************
; Timer -> TR1
;***************************************************

	MOVLW 7	; Test auf >=
	SUBWF TR1_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR1_CHECK
	MOVLW 161
	SUBWF TR1,W	;F-W -> W
LABEL_TR1_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR1_ENDE

LABEL_TR1_RESET
	MOVLW 7	; Test auf >=
	SUBWF TR1_HI,F	;F-W -> F
	MOVLW 161
	SUBWF TR1,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR1_HI,F

LABEL_TR1_SET	; toggel output
	BTFSC S0,6
	GOTO LABEL_TR1_CLR
	BSF S0,6
	GOTO LABEL_TR1_ENDE
LABEL_TR1_CLR
	BCF S0,6
LABEL_TR1_ENDE

;***************************************************
; Vergleich -> IF2
;***************************************************

	MOVLW 15
	BCF STATUS,RP0	; Bank 0
	SUBWF ZR2,W	; F - W -> W

LABEL_IF2_CHECK
	BCF STATUS,RP0	; Bank 0
	BTFSS STATUS,ZERO	; Test auf -> =
	GOTO LABEL_IF2_FALSE

LABEL_IF2_TRUE
	BSF S0,4
	GOTO LABEL_IF2_EXIT

LABEL_IF2_FALSE
	BCF S0,4

LABEL_IF2_EXIT
;***************************************************
; UND - Gatter -> LG4
;***************************************************

LABEL_LG4_1
	BTFSS S0,3
	GOTO LABEL_LG4_FALSE
LABEL_LG4_2
	BTFSC S0,4
	GOTO LABEL_LG4_FALSE

LABEL_LG4_TRUE
	BCF PORTB,7
	GOTO LABEL_LG4_ENDE
LABEL_LG4_FALSE
	BCF STATUS,RP0	; Bank 0
	BSF PORTB,7
LABEL_LG4_ENDE
;***************************************************
; One Shot -> OS1
;***************************************************


	BTFSS PORTB,6
	GOTO LABEL_OS1_1
	BTFSC OS1_FD,0
	GOTO LABEL_OS1_1
	BSF OS1_FD,0
	BSF S0,7
	GOTO LABEL_OS1_2
LABEL_OS1_1
	BCF STATUS,RP0	; Bank 0
	BCF S0,7
	BTFSC PORTB,6
	GOTO LABEL_OS1_2
	BCF OS1_FD,0
LABEL_OS1_2
;***************************************************
; ODER - Gatter -> LG5
;***************************************************

LABEL_LG5_1
	BCF STATUS,RP0	; Bank 0
	BTFSC S0,4
	GOTO LABEL_LG5_TRUE
LABEL_LG5_2
	BTFSC S1,2
	GOTO LABEL_LG5_TRUE
LABEL_LG5_3
	BTFSC S1,4
	GOTO LABEL_LG5_TRUE
LABEL_LG5_4
	BTFSC S1,6
	GOTO LABEL_LG5_TRUE

LABEL_LG5_FALSE
	BSF PORTB,0
	GOTO LABEL_LG5_ENDE
LABEL_LG5_TRUE
	BCF STATUS,RP0	; Bank 0
	BCF PORTB,0
LABEL_LG5_ENDE
;***************************************************
; Mono-Flop -> MF2
;***************************************************

; Luft der Impuls ?

	BTFSC MF2_FD,1
	GOTO LABEL_MF2_CHKTIME

; Test auf positive Flanke

	BTFSC MF2_FD,0
	GOTO LABEL_MF2_SETFD
	BTFSS S1,1
	GOTO LABEL_MF2_SETFD


LABEL_MF2_RESET

	CLRF MF2
	CLRF MF2_HI
	BSF MF2_FD,1
	BSF S1,2

LABEL_MF2_CHKTIME

	MOVLW 15
	BCF STATUS,RP0	; Bank 0
	SUBWF MF2_HI,W
	BTFSS STATUS,ZERO
	GOTO LABEL_MF2_CHECK
	MOVLW 66
	SUBWF MF2,W
LABEL_MF2_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_MF2_SETFD
LABEL_MF2_TO

	BCF MF2_FD,1
	BCF S1,2

LABEL_MF2_SETFD

	BCF STATUS,RP0	; Bank 0
	BTFSS S1,1
	GOTO LABEL_MF2_CLR
	BSF MF2_FD,0
	GOTO LABEL_MF2_ENDE
LABEL_MF2_CLR
	BCF STATUS,RP0	; Bank 0
	BCF MF2_FD,0

LABEL_MF2_ENDE

;***************************************************
; UND - Gatter -> LG6
;***************************************************

LABEL_LG6_1
	BTFSS PORTB,6
	GOTO LABEL_LG6_FALSE
LABEL_LG6_2
	BTFSS S1,0
	GOTO LABEL_LG6_FALSE
LABEL_LG6_3
	BTFSS PORTB,7
	GOTO LABEL_LG6_FALSE
LABEL_LG6_4
	BTFSC PORTA,1
	GOTO LABEL_LG6_FALSE

LABEL_LG6_TRUE
	BSF S1,1
	GOTO LABEL_LG6_ENDE
LABEL_LG6_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF S1,1
LABEL_LG6_ENDE
;***************************************************
; Timer -> TR2
;***************************************************

	MOVLW 38	; Test auf >=
	SUBWF TR2_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR2_CHECK
	MOVLW 38
	SUBWF TR2,W	;F-W -> W
LABEL_TR2_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR2_ENDE

LABEL_TR2_RESET
	MOVLW 38	; Test auf >=
	SUBWF TR2_HI,F	;F-W -> F
	MOVLW 38
	SUBWF TR2,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR2_HI,F

LABEL_TR2_SET	; toggel output
	BTFSC S1,0
	GOTO LABEL_TR2_CLR
	BSF S1,0
	GOTO LABEL_TR2_ENDE
LABEL_TR2_CLR
	BCF S1,0
LABEL_TR2_ENDE

;***************************************************
; UND - Gatter -> LG7
;***************************************************

LABEL_LG7_1
	BCF STATUS,RP0	; Bank 0
	BTFSC PORTB,7
	GOTO LABEL_LG7_FALSE
LABEL_LG7_2
	BTFSS S1,3
	GOTO LABEL_LG7_FALSE

LABEL_LG7_TRUE
	BSF S1,4
	GOTO LABEL_LG7_ENDE
LABEL_LG7_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF S1,4
LABEL_LG7_ENDE
;***************************************************
; Timer -> TR3
;***************************************************

	MOVLW 3	; Test auf >=
	SUBWF TR3_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR3_CHECK
	MOVLW 209
	SUBWF TR3,W	;F-W -> W
LABEL_TR3_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR3_ENDE

LABEL_TR3_RESET
	MOVLW 3	; Test auf >=
	SUBWF TR3_HI,F	;F-W -> F
	MOVLW 209
	SUBWF TR3,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR3_HI,F

LABEL_TR3_SET	; toggel output
	BTFSC S1,3
	GOTO LABEL_TR3_CLR
	BSF S1,3
	GOTO LABEL_TR3_ENDE
LABEL_TR3_CLR
	BCF S1,3
LABEL_TR3_ENDE

;***************************************************
; UND - Gatter -> LG8
;***************************************************

LABEL_LG8_1
	BCF STATUS,RP0	; Bank 0
	BTFSS PORTA,1
	GOTO LABEL_LG8_FALSE
LABEL_LG8_2
	BTFSS S1,5
	GOTO LABEL_LG8_FALSE

LABEL_LG8_TRUE
	BSF S1,6
	GOTO LABEL_LG8_ENDE
LABEL_LG8_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF S1,6
LABEL_LG8_ENDE
;***************************************************
; Timer -> TR4
;***************************************************

	MOVLW 1	; Test auf >=
	SUBWF TR4_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR4_CHECK
	MOVLW 135
	SUBWF TR4,W	;F-W -> W
LABEL_TR4_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR4_ENDE

LABEL_TR4_RESET
	MOVLW 1	; Test auf >=
	SUBWF TR4_HI,F	;F-W -> F
	MOVLW 135
	SUBWF TR4,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR4_HI,F

LABEL_TR4_SET	; toggel output
	BTFSC S1,5
	GOTO LABEL_TR4_CLR
	BSF S1,5
	GOTO LABEL_TR4_ENDE
LABEL_TR4_CLR
	BCF S1,5
LABEL_TR4_ENDE

;***************************************************
; Zhler -> ZR3
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BTFSS S3,0	; Reset ?
	GOTO LABEL_ZR3_COUNT
	CLRF ZR3
	GOTO LABEL_ZR3_SETOUT

LABEL_ZR3_COUNT

; Test auf positive Flanke

	BCF STATUS,RP0	; Bank 0
	BTFSC ZR3_FD,0
	GOTO LABEL_ZR3_SETFD
	BTFSS S2,3
	GOTO LABEL_ZR3_SETFD

	INCF ZR3,F

LABEL_ZR3_SETOUT

LABEL_ZR3_SETFD

	BCF STATUS,RP0	; Bank 0
	BTFSS S2,3
	GOTO LABEL_ZR3_SETFD2
	BSF ZR3_FD,0
	GOTO LABEL_ZR3_END
LABEL_ZR3_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF ZR3_FD,0
LABEL_ZR3_END

;***************************************************
; Zhler -> ZR4
;***************************************************

	BTFSS S3,3	; Reset ?
	GOTO LABEL_ZR4_COUNT
	CLRF ZR4
	GOTO LABEL_ZR4_SETOUT

LABEL_ZR4_COUNT

; Test auf positive Flanke

	BCF STATUS,RP0	; Bank 0
	BTFSC ZR4_FD,0
	GOTO LABEL_ZR4_SETFD
	BTFSS S3,1
	GOTO LABEL_ZR4_SETFD

	INCF ZR4,F

LABEL_ZR4_SETOUT

LABEL_ZR4_SETFD

	BCF STATUS,RP0	; Bank 0
	BTFSS S3,1
	GOTO LABEL_ZR4_SETFD2
	BSF ZR4_FD,0
	GOTO LABEL_ZR4_END
LABEL_ZR4_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF ZR4_FD,0
LABEL_ZR4_END

;***************************************************
; RS-FLIP-FLOP -> RS1
;***************************************************

	BTFSC S2,6
	GOTO LABEL_RS1_RESET
	BTFSS S2,4
	GOTO LABEL_RS1_ENDE
	BSF S2,0	; Ausgang setzen
	GOTO LABEL_RS1_ENDE
LABEL_RS1_RESET
	BCF STATUS,RP0	; Bank 0
	BCF S2,0	; Ausgang zurcksetzen
LABEL_RS1_ENDE

;***************************************************
; Timer -> TR5
;***************************************************

	MOVLW 76	; Test auf >=
	BCF STATUS,RP0	; Bank 0
	SUBWF TR5_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR5_CHECK
	MOVLW 75
	SUBWF TR5,W	;F-W -> W
LABEL_TR5_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR5_ENDE

LABEL_TR5_RESET
	MOVLW 76	; Test auf >=
	SUBWF TR5_HI,F	;F-W -> F
	MOVLW 75
	SUBWF TR5,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR5_HI,F

LABEL_TR5_SET	; toggel output
	BTFSC S2,1
	GOTO LABEL_TR5_CLR
	BSF S2,1
	GOTO LABEL_TR5_ENDE
LABEL_TR5_CLR
	BCF S2,1
LABEL_TR5_ENDE

;***************************************************
; UND - Gatter -> LG9
;***************************************************

LABEL_LG9_1
	BCF STATUS,RP0	; Bank 0
	BTFSS S2,0
	GOTO LABEL_LG9_FALSE
LABEL_LG9_2
	BTFSS S2,1
	GOTO LABEL_LG9_FALSE
LABEL_LG9_3
	BTFSC S2,2
	GOTO LABEL_LG9_FALSE

LABEL_LG9_TRUE
	BSF S2,3
	GOTO LABEL_LG9_ENDE
LABEL_LG9_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF S2,3
LABEL_LG9_ENDE
;***************************************************
; Mono-Flop -> MF3
;***************************************************

; Luft der Impuls ?

	BTFSC MF3_FD,1
	GOTO LABEL_MF3_CHKTIME

; Test auf negative Flanke

	BTFSS MF3_FD,0
	GOTO LABEL_MF3_SETFD
	BTFSC S1,7
	GOTO LABEL_MF3_SETFD


LABEL_MF3_RESET

	CLRF MF3
	CLRF MF3_HI
	BSF MF3_FD,1
	BSF S2,4

LABEL_MF3_CHKTIME

	MOVLW 0
	BCF STATUS,RP0	; Bank 0
	SUBWF MF3_HI,W
	BTFSS STATUS,ZERO
	GOTO LABEL_MF3_CHECK
	MOVLW 78
	SUBWF MF3,W
LABEL_MF3_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_MF3_SETFD
LABEL_MF3_TO

	BCF MF3_FD,1
	BCF S2,4

LABEL_MF3_SETFD

	BCF STATUS,RP0	; Bank 0
	BTFSS S1,7
	GOTO LABEL_MF3_CLR
	BSF MF3_FD,0
	GOTO LABEL_MF3_ENDE
LABEL_MF3_CLR
	BCF STATUS,RP0	; Bank 0
	BCF MF3_FD,0

LABEL_MF3_ENDE

;***************************************************
; Vergleich -> IF3
;***************************************************

	MOVLW 180
	SUBWF ZR3,W	; F - W -> W

LABEL_IF3_CHECK
	BCF STATUS,RP0	; Bank 0
	BTFSS STATUS,ZERO	; Test auf -> =
	GOTO LABEL_IF3_FALSE

LABEL_IF3_TRUE
	BSF S2,2
	GOTO LABEL_IF3_EXIT

LABEL_IF3_FALSE
	BCF S2,2

LABEL_IF3_EXIT
;***************************************************
; UND - Gatter -> LG10
;***************************************************

LABEL_LG10_1
	BTFSS S2,2
	GOTO LABEL_LG10_FALSE
LABEL_LG10_2
	BTFSS S2,1
	GOTO LABEL_LG10_FALSE
LABEL_LG10_3
	BTFSC S2,5
	GOTO LABEL_LG10_FALSE

LABEL_LG10_TRUE
	BSF S3,1
	GOTO LABEL_LG10_ENDE
LABEL_LG10_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF S3,1
LABEL_LG10_ENDE
;***************************************************
; Vergleich -> IF4
;***************************************************

	MOVLW 30
	SUBWF ZR4,W	; F - W -> W

LABEL_IF4_CHECK
	BCF STATUS,RP0	; Bank 0
	BTFSS STATUS,ZERO	; Test auf -> =
	GOTO LABEL_IF4_FALSE

LABEL_IF4_TRUE
	BSF S2,5
	GOTO LABEL_IF4_EXIT

LABEL_IF4_FALSE
	BCF S2,5

LABEL_IF4_EXIT
;***************************************************
; One Shot -> OS2
;***************************************************


	BTFSS S2,5
	GOTO LABEL_OS2_1
	BTFSC OS2_FD,0
	GOTO LABEL_OS2_1
	BSF OS2_FD,0
	BSF S2,7
	GOTO LABEL_OS2_2
LABEL_OS2_1
	BCF STATUS,RP0	; Bank 0
	BCF S2,7
	BTFSC S2,5
	GOTO LABEL_OS2_2
	BCF OS2_FD,0
LABEL_OS2_2
;***************************************************
; One Shot -> OS3
;***************************************************


	BCF STATUS,RP0	; Bank 0
	BTFSS S2,2
	GOTO LABEL_OS3_1
	BTFSC OS3_FD,0
	GOTO LABEL_OS3_1
	BSF OS3_FD,0
	BSF S3,2
	GOTO LABEL_OS3_2
LABEL_OS3_1
	BCF STATUS,RP0	; Bank 0
	BCF S3,2
	BTFSC S2,2
	GOTO LABEL_OS3_2
	BCF OS3_FD,0
LABEL_OS3_2
;***************************************************
; ODER - Gatter -> LG11
;***************************************************

LABEL_LG11_1
	BCF STATUS,RP0	; Bank 0
	BTFSC S2,6
	GOTO LABEL_LG11_TRUE
LABEL_LG11_2
	BTFSC S3,2
	GOTO LABEL_LG11_TRUE

LABEL_LG11_FALSE
	BCF S3,3
	GOTO LABEL_LG11_ENDE
LABEL_LG11_TRUE
	BCF STATUS,RP0	; Bank 0
	BSF S3,3
LABEL_LG11_ENDE
;***************************************************
; ODER - Gatter -> LG12
;***************************************************

LABEL_LG12_1
	BTFSC S2,6
	GOTO LABEL_LG12_TRUE
LABEL_LG12_2
	BTFSC S2,7
	GOTO LABEL_LG12_TRUE

LABEL_LG12_FALSE
	BCF S3,0
	GOTO LABEL_LG12_ENDE
LABEL_LG12_TRUE
	BCF STATUS,RP0	; Bank 0
	BSF S3,0
LABEL_LG12_ENDE
;***************************************************
; ODER - Gatter -> LG13
;***************************************************

LABEL_LG13_1
	BTFSC PORTA,1
	GOTO LABEL_LG13_TRUE
LABEL_LG13_2
	BTFSC S1,7
	GOTO LABEL_LG13_TRUE

LABEL_LG13_FALSE
	BCF S2,6
	GOTO LABEL_LG13_ENDE
LABEL_LG13_TRUE
	BCF STATUS,RP0	; Bank 0
	BSF S2,6
LABEL_LG13_ENDE
;***************************************************
; EXKLUSIVODER - Gatter -> LG14
;***************************************************

	CLRF SYS_TMP1
	BTFSS PORTA,2
	GOTO LABEL_LG14_1
	INCF SYS_TMP1,F

LABEL_LG14_1
	BTFSC PORTB,6
	GOTO LABEL_LG14_2
	INCF SYS_TMP1,F

LABEL_LG14_2
	DECF SYS_TMP1,F
	BTFSC STATUS,ZERO
	BCF S1,7
	BTFSS STATUS,ZERO
	BSF S1,7
;***************************************************
; ODER - Gatter -> LG15
;***************************************************

LABEL_LG15_1
	BTFSC S2,2
	GOTO LABEL_LG15_TRUE
LABEL_LG15_2
	BTFSC S3,4
	GOTO LABEL_LG15_TRUE
LABEL_LG15_3
	BTFSC S4,2
	GOTO LABEL_LG15_TRUE

LABEL_LG15_FALSE
	BSF PORTB,1
	GOTO LABEL_LG15_ENDE
LABEL_LG15_TRUE
	BCF STATUS,RP0	; Bank 0
	BCF PORTB,1
LABEL_LG15_ENDE
;***************************************************
; UND - Gatter -> LG16
;***************************************************

LABEL_LG16_1
	BTFSS PORTA,2
	GOTO LABEL_LG16_FALSE
LABEL_LG16_2
	BTFSC PORTA,1
	GOTO LABEL_LG16_FALSE

LABEL_LG16_TRUE
	BSF S3,4
	GOTO LABEL_LG16_ENDE
LABEL_LG16_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF S3,4
LABEL_LG16_ENDE
;***************************************************
; Zhler -> ZR5
;***************************************************

	BTFSS S4,3	; Reset ?
	GOTO LABEL_ZR5_COUNT
	CLRF ZR5
	GOTO LABEL_ZR5_SETOUT

LABEL_ZR5_COUNT

; Test auf positive Flanke

	BCF STATUS,RP0	; Bank 0
	BTFSC ZR5_FD,0
	GOTO LABEL_ZR5_SETFD
	BTFSS S4,0
	GOTO LABEL_ZR5_SETFD

	INCF ZR5,F

LABEL_ZR5_SETOUT

LABEL_ZR5_SETFD

	BCF STATUS,RP0	; Bank 0
	BTFSS S4,0
	GOTO LABEL_ZR5_SETFD2
	BSF ZR5_FD,0
	GOTO LABEL_ZR5_END
LABEL_ZR5_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF ZR5_FD,0
LABEL_ZR5_END

;***************************************************
; Timer -> TR6
;***************************************************

	MOVLW 76	; Test auf >=
	SUBWF TR6_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR6_CHECK
	MOVLW 75
	SUBWF TR6,W	;F-W -> W
LABEL_TR6_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR6_ENDE

LABEL_TR6_RESET
	MOVLW 76	; Test auf >=
	SUBWF TR6_HI,F	;F-W -> F
	MOVLW 75
	SUBWF TR6,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR6_HI,F

LABEL_TR6_SET	; toggel output
	BTFSC S3,5
	GOTO LABEL_TR6_CLR
	BSF S3,5
	GOTO LABEL_TR6_ENDE
LABEL_TR6_CLR
	BCF S3,5
LABEL_TR6_ENDE

;***************************************************
; UND - Gatter -> LG17
;***************************************************

LABEL_LG17_1
	BCF STATUS,RP0	; Bank 0
	BTFSS S3,5
	GOTO LABEL_LG17_FALSE
LABEL_LG17_2
	BTFSS S3,7
	GOTO LABEL_LG17_FALSE

LABEL_LG17_TRUE
	BSF S4,0
	GOTO LABEL_LG17_ENDE
LABEL_LG17_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF S4,0
LABEL_LG17_ENDE
;***************************************************
; RS-FLIP-FLOP -> RS2
;***************************************************

	BTFSC S4,4
	GOTO LABEL_RS2_RESET
	BTFSS S3,6
	GOTO LABEL_RS2_ENDE
	BSF S3,7	; Ausgang setzen
	GOTO LABEL_RS2_ENDE
LABEL_RS2_RESET
	BCF STATUS,RP0	; Bank 0
	BCF S3,7	; Ausgang zurcksetzen
LABEL_RS2_ENDE

;***************************************************
; One Shot -> OS4
;***************************************************


	BCF STATUS,RP0	; Bank 0
	BTFSS S0,2
	GOTO LABEL_OS4_1
	BTFSC OS4_FD,0
	GOTO LABEL_OS4_1
	BSF OS4_FD,0
	BSF S3,6
	GOTO LABEL_OS4_2
LABEL_OS4_1
	BCF STATUS,RP0	; Bank 0
	BCF S3,6
	BTFSC S0,2
	GOTO LABEL_OS4_2
	BCF OS4_FD,0
LABEL_OS4_2
;***************************************************
; Vergleich -> IF5
;***************************************************

	MOVLW 30
	BCF STATUS,RP0	; Bank 0
	SUBWF ZR5,W	; F - W -> W

LABEL_IF5_CHECK
	BCF STATUS,RP0	; Bank 0
	BTFSS STATUS,ZERO	; Test auf -> =
	GOTO LABEL_IF5_FALSE

LABEL_IF5_TRUE
	BSF S4,1
	GOTO LABEL_IF5_EXIT

LABEL_IF5_FALSE
	BCF S4,1

LABEL_IF5_EXIT
;***************************************************
; UND - Gatter -> LG18
;***************************************************

LABEL_LG18_1
	BTFSC S4,1
	GOTO LABEL_LG18_FALSE
LABEL_LG18_2
	BTFSS S3,7
	GOTO LABEL_LG18_FALSE

LABEL_LG18_TRUE
	BSF S4,2
	GOTO LABEL_LG18_ENDE
LABEL_LG18_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF S4,2
LABEL_LG18_ENDE
;***************************************************
; ODER - Gatter -> LG19
;***************************************************

LABEL_LG19_1
	BTFSC S0,2
	GOTO LABEL_LG19_TRUE
LABEL_LG19_2
	BTFSC PORTA,2
	GOTO LABEL_LG19_TRUE

LABEL_LG19_FALSE
	BCF S4,3
	GOTO LABEL_LG19_ENDE
LABEL_LG19_TRUE
	BCF STATUS,RP0	; Bank 0
	BSF S4,3
LABEL_LG19_ENDE
;***************************************************
; ODER - Gatter -> LG20
;***************************************************

LABEL_LG20_1
	BTFSC S4,1
	GOTO LABEL_LG20_TRUE
LABEL_LG20_2
	BTFSC PORTA,2
	GOTO LABEL_LG20_TRUE

LABEL_LG20_FALSE
	BCF S4,4
	GOTO LABEL_LG20_ENDE
LABEL_LG20_TRUE
	BCF STATUS,RP0	; Bank 0
	BSF S4,4
LABEL_LG20_ENDE
;****************************************

	GOTO MAIN


	END

